#!/bin/sh

# group_add.sh - 롼פɲä

# 
MIN_GID=1000
MAX_GID=60000

# show_usage
#     Ȥɽؿ
show_usage() {
    echo 'usage: group_add.sh [-g gid] group'
    exit 1
}

# ޥɥ饤󥪥ץϤ
gid=''
while getopts 'g:' flag; do
    case "$flag" in
	g)
	    gid=$OPTARG
	    ;;
	*)
	    show_usage
	    ;;
    esac
done
shift `expr $OPTIND - 1`
[ -z "$1" ] && show_usage
group="$1"

# /etc/groupɤ߹ǡ롼ID
# 롼̾νʣå
# ʡ-gץץǻꤵƤˤϡʣ̵å

# while...doneФƥ쥯ȤԤȡ롼Τ֥Ǽ
# ԤƤޤSolairsΡŪʡ/bin/shǤϡ֥Ǥ
# exitϥ֥ΤߤλΤǡޤʤexecǥ쥯
# ȤԤХȥǼ¹ԤΤʤ

newgid=$MIN_GID
exec 3<&0 </etc/group
while read entry; do
    echo "$entry" | grep '^#' >/dev/null && continue  # ȹԤɤФ
    
    # ȥեɤʬ䤹
    # ѥɤΥեɤξ硢setڤʬ褦ˡxפ
    # 
    IFS=":"
    set -- `echo "$entry" | sed 's/::/:x:/g'`
    IFS="$_IFS"
    n=$1
    i=$3

    # 롼פνʣå
    if [ "$n" = "$group" ]; then
	echo "Group $group already exists."
	exit 1
    fi

    # 롼IDå
    if [ -z "$gid" ]; then
	[ $i -lt $MAX_GID -a $i -gt $newgid ] && newgid=`expr $i + 1`
    else
	if [ $gid -eq $i ]; then
	    echo "Gid $gid already exists."
	    exit 1
	fi
    fi
done
exec 0<&3
[ -z "$gid" ] && gid=$newgid

# /etc/group˿ȥɲä
echo "$group:x:$gid:" >>/etc/group
echo "Group $group, gid $gid has been created."
exit 0
