#!/bin/sh

# ftp_upload.sh - ftpǥե򥢥åץɤ

# show_help
#     إפɽؿ
show_help() {
    cat <<'EOF'
usage: ftp_upload.sh [options...] ftp_host remote_dir files ...
options:
  -u user      set FTP login name.
  -p password  set FTP login password.
  -P           toggle passive mode.
  -h           show this help message.
EOF
}

# echoޥɤθߴĴ٤
if [ "`echo '\c'`" = "\c" ]; then
    ECHO_N=-n
    ECHO_C=
else
    ECHO_N=
    ECHO_C="\c"
fi

# testޥɤθߴĴ٤
if /bin/sh -c '[ 1 -lt 2]' 2>/dev/null; then
    command=""
else
    command="command"
fi

# 
ftp_user=`whoami`
ftp_pass=
toggle_passive="NO"

# ޥɥ饤󥪥ץĴ٤
while getopts 'u:p:Ph' flag; do
    case $flag in
	u)
	    ftp_user=$OPTARG
	    ;;
	p)
	    ftp_pass=$OPTARG
	    ;;
	P)
	    toggle_passive="YES"
	    ;;
	*)
	    show_help
	    exit 1
    esac
done
shift `expr $OPTIND - 1`

# ץ¾ˡʤȤ3Ĥΰɬ
if $command [ $# -lt 3 ]; then
    show_help
    exit 1
fi

ftp_host=$1
ftp_dir=$2
shift 2

# ѥɤꤵƤʤ硢䤤碌
if [ -z "$ftp_pass" ]; then
    stty -echo
    echo $ECHO_N "Enter FTP password: $ECHO_C"
    read ftp_pass
    stty echo
    echo
fi

# expectΥץȤ
expect_script="#expectץ Ϥޤ

set timeout 20
set ftp_host \"${ftp_host}\"
set ftp_dir \"${ftp_dir}\"
set toggle_passive \"${toggle_passive}\"
set ftp_user \"${ftp_user}\"
set ftp_pass \"${ftp_pass}\"
array set files {"

# 륹ץȤ
for local_file do  # žեΰˤƤ
    remote_file=`basename "${local_file}"`
    expect_script="${expect_script}
  \"${remote_file}\" \"${local_file}\""
done
# expect

expect_script="${expect_script}
}

#ޤǥ֥륯
"'
#饷󥰥륯

spawn ftp $ftp_host

expect {
  "ftp>" { exit 1 }      ;# ³Ǥʤ
  "Name "
}
send "$ftp_user\r"

expect "Password:"
send "$ftp_pass\r"
expect {
  "230 " { }
  "ftp>" { exit 1 }      ;# ѥɤ㤦
}

if { $toggle_passive == "YES" } {
  expect "ftp>"
  send "passive\r"   ;# ɬפʤpassive⡼ɤ
}

expect "ftp>"
send "cd \"$ftp_dir\"\r"
expect {
  "250 " { }
  "ftp>" { exit 1 }      ;# cdǤʤ
}

# եž
set timeout -1       ;# žϥॢȴƻ뤷ʤ
foreach remote_file [array names files] {
  set local_file $files($remote_file)
  expect "ftp>"
  send "put \"$local_file\" \"$remote_file\"\r"
}

# ³λ
expect "ftp>"
send "quit\r"
expect eof

#expectץȽ
'

expect -c "${expect_script}"
